Const C_BUSY = 20

Function Reload()

	;clear out old data
	For i.island = Each island
		Delete i
;		For index=0 To DATA_HIST ;fast clear island data
;			i\rulerid[index]=0
;			i\rulername$[index]=""
;			i\allianceid[index]=0
;			i\alliancetag$[index]=""
;		Next
;;		c=c+1 : If c=C_BUSY : ServerBusy() : c=0 : EndIf	
	Next

	For p.player = Each player
		Delete p
;		For index=0 To DATA_HIST ;fast clear player data
;			p\name$[index]=""
;			p\islands[index]=0
;			p\score[index]=0
;			p\rank[index]=0
;			p\allianceid[index]=0
;			p\alliancetag$[index]=""
;			p\inactive[index]=0
;		Next
;;		c=c+1 : If c=C_BUSY : ServerBusy() : c=0 : EndIf
	Next
		
	For a.alliance = Each alliance
		Delete a
;		c=c+1 : If c=C_BUSY : ServerBusy() : c=0 : EndIf
	Next
	
;	For u.user = Each user
;		Delete u
;		c=c+1 : If c=C_BUSY : ServerBusy() : c=0 : EndIf
;	Next
	
	;load ik data
	DatabaseIndex() ;get last_data index number
		
	;WriteLog ("Loading "+(last_data+1)+" data sets")
	
	;count file data backwards and db records forwards, load data
	For file_index = last_data To 0 Step -1
	
		;date string
		file=ReadFile(DATA_PATH$+file_index+"-ok.txt")
		date$(db_index) = ReadLine$(file)
		CloseFile file
	
		;DATA
		loadislands (file_index,db_index)
;		ServerBusy()
		loadplayers (file_index,db_index)
;		ServerBusy()
		loadalliances (file_index,db_index)
;		ServerBusy()
		
		;WriteLog (file_index+" loaded")
		
		db_index = db_index + 1
		If db_index > DATA_HIST Then Exit
	Next	

	;usage of last_data changes here from file to db index!
	;clip last_data if more than DATA_HIST records on file
	If last_data > DATA_HIST Then last_data = DATA_HIST
		
	;set activity counters
	ActivityPlayer()
	ActivityAlliance()

	;load user file
	;WriteLog ("Loading users")
;	LoadUsers()
	
	;set time of last update
;	LastModified()

;	LoadSpy()
	
	;count some statistics
;	For a.alliance = Each alliance
;		a_count = a_count + 1
;	Next
	
;	For p.player = Each player
;		p_count = p_count + 1
;	Next
	
	island_count = 0
	For i.island = Each island
		island_count = island_count + 1
	Next

End Function




Function DatabaseIndex()
	
	last_data = -1
	test = 0
	While last_data = -1
		;check if file exists
		file = ReadFile (DATA_PATH$ + test + "-ok.txt")
		
		If file Then
			;exists, move to next
			CloseFile file
			
			test = test + 1
		Else
			;not exist, use previous value as last database
			;CloseFile file
			
			last_data = test - 1
		EndIf			
	Wend
	
	If last_data = -1 Then RuntimeError "No data found!" 
	
End Function


;cache islands
Function LoadIslands(file_index,db_index)

	file = ReadFile (DATA_PATH$+file_index+"-islands.txt") ;open file
	

	count = ReadLine (file) ; get number of records
	
	For c=1 To count
		ocean = ReadLine (file) ;get isle id
		sector = ReadLine (file)
		isle = ReadLine (file)
		
		For i.island=Each island ;loop existing islands
			If i\ocean = ocean And i\sector = sector And i\isle = isle ;island already in db
				i\rulerid[db_index] = ReadLine (file) ;update island for this index
				i\rulername$[db_index] = ReadLine (file)
				i\allianceid[db_index] = ReadLine (file)
				i\alliancetag$[db_index] = ReadLine (file)
				Goto isleupdated
			EndIf
		Next
			

		i.island = New island ;island not found, add to list
		i\ocean = ocean
		i\sector = sector
		i\isle = isle

		ocean_r = (i\ocean-1)Mod 5
		sector_r = (i\sector-1)Mod 10
		isle_r = (i\isle-1)Mod 10
		i\x = 100*(ocean_r) + 10*(sector_r) + (isle_r)
		i\y = ((i\ocean-1)-ocean_r)*20 + ((i\sector-1)-sector_r) + ((i\isle-1)-isle_r)/10

		i\rulerid[db_index] = ReadLine (file)
		i\rulername$[db_index] = ReadLine (file)
		i\allianceid[db_index] = ReadLine (file)
		i\alliancetag$[db_index] = ReadLine (file)
		
		.isleupdated
	Next
	
	CloseFile file
	
End Function

;cache players
Function LoadPlayers(file_index,db_index)
	file = ReadFile (DATA_PATH+file_index+"-players.txt")
	

	count = ReadLine (file)
	
	For c=1 To count
		id = ReadLine (file) ;get playerid
		
		For p.player = Each player ;loop existing players
			If p\id = id ;player already in db
				p\name$[db_index] = ReadLine (file)
				p\islands[db_index] = ReadLine (file)
				p\score[db_index] = ReadLine (file)
				p\rank[db_index] = ReadLine (file)
				p\allianceid[db_index] = ReadLine (file)
				p\alliancetag$[db_index] = ReadLine (file)
				Goto playerupdated
			EndIf
		Next
	
		p.player = New player
		p\id = id
		p\name$[db_index] = ReadLine (file)
		p\islands[db_index] = ReadLine (file)
		p\score[db_index] = ReadLine (file)
		p\rank[db_index] = ReadLine (file)
		p\allianceid[db_index] = ReadLine (file)
		p\alliancetag$[db_index] = ReadLine (file)
		
		;If p\rank[db_index]=0 Or p\id = 0 Then Delete p ;corrupt database, delete record!
		
		.playerupdated
	Next
	
	CloseFile file
	
End Function


;cache alliances
Function LoadAlliances(file_index,db_index)
	file = ReadFile (DATA_PATH+file_index+"-alliances.txt")
	

	count = ReadLine (file)
	
	For c=1 To count
		id = ReadLine (file)
		
		For a.alliance = Each alliance
			If a\id = id
				a\tag$[db_index] = ReadLine (file)
				a\score[db_index] = ReadLine (file)
				a\rank[db_index] = ReadLine (file)
				a\members[db_index] = ReadLine (file)
				a\islands[db_index] = ReadLine (file)
				Goto allianceupdated
			EndIf
		Next
		
		a.alliance = New alliance
		a\id = id
		a\tag$[db_index] = ReadLine (file)
		a\score[db_index] = ReadLine (file)
		a\rank[db_index] = ReadLine (file)
		a\members[db_index] = ReadLine (file)
		a\islands[db_index] = ReadLine (file)
		
		;If a\rank[db_index]=0 Or a\id = 0 Then Delete a ;corrupt database, delete record!
		
		.allianceupdated
	Next
	
	CloseFile file
	
End Function





;load registered user list
;Function LoadUsers()
;
;	file = ReadFile ("users.txt") 
;	
;	;user file not found!
;	If Not file Then
;		Return False
;	EndIf
;
;	;wipe old list
;	For u.user = Each user
;		Delete u
;	Next
;	
;	;load list
;	While Not Eof(file)
;		u.user = New user
;		u\id = ReadLine$(file)
;		u\pass$ = ReadLine$(file)
;		
;		;find username
;		For p.player = Each player
;			If p\id = u\id Then
;				u\username$ = p\name$[0]
;				u\allianceid = p\allianceid[0]
;			EndIf
;		Next
;	Wend
;	
;	CloseFile file
;	
;End Function


;Function AddUser(un$,pw$)
;
;	For u.user = Each user
;		If u\username$ = un$ Then Return False
;	Next
;	
;	u.user=New user
;	u\username$ = un$
;	u\pass$ = pw$
;
;	For p.player = Each player
;		If p\name$[0] = u\username$ Then
;			u\id = p\id
;			u\allianceid = p\allianceid[0]
;			Exit
;		EndIf
;	Next
;	
;	If Not u\id Then
;		Delete u
;		Return False
;	EndIf
;	
;	CopyFile "users.txt","users.bak"
;	file=WriteFile ("users.txt")
;	
;	If Not file Then Return False
;	
;	For u.user =Each user
;		WriteLine file, u\id
;		WriteLine file, u\pass$
;	Next
;	
;	CloseFile file
;	
;	Return True
;	
;End Function


Function ActivityPlayer()
	For p.player = Each player ;loop players and history
		p\inactive[last_data]=1
		For index=last_data-1 To 0 Step -1
			If p\score[index] <= p\score[index+1] ;inactive / no score change
				p\inactive[index]=p\inactive[index+1]+1 ;increment inactive counter
			Else
				p\inactive[index]=0 ;reset counter
			EndIf
		Next
	Next
End Function

Function ActivityAlliance()
	For a.alliance = Each alliance ;loop alliance and history
		a\inactive[last_data]=1
		For index=last_data-1 To 0 Step -1
			If a\score[index] <= a\score[index+1] ;inactive / no score change
				a\inactive[index]=a\inactive[index+1]+1 ;increment inactive counter
			Else
				a\inactive[index]=0 ;reset counter
			EndIf
		Next
	Next
End Function



;Function LastModified()
;	Local time$,date$,weekday$,day,mon$,month,year
;	Local c,d,m,y
;	
;	;; capture date and time
;	time$=CurrentTime$()
;	date$=CurrentDate$()
;	
;	;; parse date string
;    day = Left(date$, Instr(date$, " ") - 1)
;    year = Mid(date$, Instr(date$, " ", Instr(date$, " ")+1)+1, 4)
;    mon$ = Mid(date$, Instr(date$, " ")+1, 3)
;
;	;; get month number from month name
;    Select Upper$(mon$)
;        Case "JAN" : month = 1
;        Case "FEB" : month = 2
;        Case "MAR" : month = 3
;        Case "APR" : month = 4
;        Case "MAY" : month = 5
;        Case "JUN" : month = 6
;        Case "JUL" : month = 7
;        Case "AUG" : month = 8
;        Case "SEP" : month = 9
;        Case "OCT" : month = 10
;        Case "NOV" : month = 11
;        Case "DEC" : month = 12
;    End Select
;
;	;; get day of week
;	c=(14-month)/12
;	y=year-c
;	m=month+(12*c)-2
;	d=(day+y+(y/4)-(y/100)+(y/400)+((31*m)/12)) Mod 7
;	Select d
;		Case 0 : weekday$="Sun"
;		Case 1 : weekday$="Mon"
;		Case 2 : weekday$="Tue"
;		Case 3 : weekday$="Wed"
;		Case 4 : weekday$="Thu"
;		Case 5 : weekday$="Fri"
;		Case 6 : weekday$="Sat" 
;	End Select
;	
;	;; http format date
;	last_modified$ = weekday$+", "+date$+" "+time$+" GMT"
;
;End Function


Function WriteLog()
	;open existing log
	logfile = OpenFile (LOG_PATH$+CurrentDate$()+LOG_FILE$)

	If Not logfile
		;create if doesn't exist
		logfile = WriteFile (LOG_PATH$+CurrentDate$()+LOG_FILE$)
		If Not logfile Then Return False ;abort if still not opened
		WriteLine logfile,Chr$(34)+"Date"+Chr$(34)+","+Chr$(34)+"Time"+Chr$(34)+","+Chr$(34)+"GET"+Chr$(34)+","+Chr$(34)+"User-Agent"+Chr$(34)+","+Chr$(34)+"Referer"+Chr$(34)
	
	Else
		;go to end of file
		SeekFile (logfile, FileSize (LOG_PATH$+CurrentDate$()+LOG_FILE$))
	EndIf
	
	;write entry to log
	WriteLine logfile,Chr$(34)+CurrentDate$()+Chr$(34)+","+Chr$(34)+CurrentTime$()+Chr$(34)+","+Chr$(34)+get$+Chr$(34)+","+Chr$(34)+agent$+Chr$(34)+","+Chr$(34)+referer$+Chr$(34)	
	CloseFile logfile
	
;	Print "("+user$+") "+get$

End Function



;Function ServerBusy()
;	;; mini server to handle requests while reloading database
;	Local stream, in$
;	stream = AcceptTCPStream (server)
;	If stream Then
;		Repeat
;			in$ = ReadLine (stream)
;		Until in$ = ""
;	
;		WriteLine stream, "HTTP/1.1 503 Service Unavailable"
;		WriteLine stream, "Server: CuccosTools/"+VERSION$
;		WriteLine stream, "Connection: close"
;		WriteLine stream, "Cache-Control: no-cache"
;		WriteLine stream, "Content-Type: text/html; charset=utf-8"
;		WriteLine stream, ""
;		WriteLine stream, "<html><body><p>Reloading database...</p></body></html>"
;		CloseTCPStream stream
;	EndIf
;End Function



;Function SaveSpy()
;	
;	CopyFile SPY_PATH$+"reports.txt",SPY_PATH$+CurrentDate()+" reports.bak"
;	file=WriteFile (SPY_PATH$+"reports.txt")
;	
;	If Not file Then Return False
;	
;	For s.spy = Each spy
;		c = c + 1
;	Next
;	
;	WriteLine file, c
;	
;	For s.spy = Each spy
;		WriteLine file, s\id$
;		WriteLine file, s\ocean
;		WriteLine file, s\sector
;		WriteLine file, s\isle
;		WriteLine file, s\rulerid
;		WriteLine file, s\rulername$
;		WriteLine file, s\allianceid
;		WriteLine file, s\alliancetag$
;		WriteLine file, s\date$
;		WriteLine file, Replace$(s\report$, Chr$($0D)+Chr$($0A), "%%")
;		WriteLine file, s\submit
;		WriteLine file, s\public
;	Next
;	
;	CloseFile file
;	Return True
;End Function

;Function LoadSpy()
;
;	file=ReadFile (SPY_PATH$+"reports.txt")
;	
;	If Not file Then Return False
;	
;	For s.spy = Each spy
;		Delete s
;	Next
;	
;	c = ReadLine( file )
;	
;	For count=1 To c
;		s.spy = New spy
;		s\id$ = ReadLine( file )
;		s\ocean = ReadLine( file )
;		s\sector = ReadLine( file )
;		s\isle = ReadLine( file )
;		s\rulerid = ReadLine( file )
;		s\rulername$ = ReadLine( file )
;		s\allianceid = ReadLine( file )
;		s\alliancetag$ = ReadLine( file )
;		s\date$ = ReadLine( file )
;		s\report$ = Replace$( ReadLine( file ), "%%", Chr$($0D)+Chr$($0A) )
;		s\submit = ReadLine( file )
;		s\public = ReadLine( file )
;	Next
;	
;	CloseFile file
;	Return True
;End Function


Function ReadIsland(html,o,s,i,index)

	file=ReadFile (DATA_PATH$+index+"-islands.txt")
	
	If Not file Then Return False ; escape if not found
	
	count = ReadLine (file) ; get number of records
	
	For c=1 To count
		ocean = ReadLine (file) ; read island data
		sector = ReadLine (file)
		isle = ReadLine (file)
		rulerid = ReadLine (file)
		rulername$ = ReadLine (file)
		allianceid = ReadLine (file)
		alliancetag$ = ReadLine (file)
		
		If ocean = o And sector = s And isle = i Then ; match isle
		
			WriteLine html, "<tr>"
			WriteLine html, "<td>"+index+"</td>"
;			WriteLine html, "<td>"+ocean+":"+sector+":"+isle+"</td>"
			WriteLine html, "<td>"+rulerid+"</td>"
			WriteLine html, "<td>"+rulername$+"</td>"
			WriteLine html, "<td>"+allianceid+"</td>"
			WriteLine html, "<td>"+alliancetag$+"</td>"
			
		EndIf
	Next
	
	CloseFile file
	Return True
End Function


Function ReadAlliance(html,a,index)

	file=ReadFile (DATA_PATH$+index+"-alliances.txt")
	
	If Not file Then Return False ; escape if not found
	
	count = ReadLine (file) ; get number of records
	
	For c=1 To count
		id = ReadLine (file) ; read alliance data
		tag$ = ReadLine (file)
		score = ReadLine (file)
		rank = ReadLine (file)
		members = ReadLine (file)
		islands = ReadLine (file)
		
		If id = a Then ; match alliance
		
			WriteLine html, "<tr>"
			WriteLine html, "<td>"+index+"</td>"
;			WriteLine html, "<td>"+id+"</td>"
			WriteLine html, "<td>"+tag$+"</td>"
			WriteLine html, "<td>"+score+"</td>"
			WriteLine html, "<td>"+rank+"</td>"
			WriteLine html, "<td>"+members+"</td>"
			WriteLine html, "<td>"+islands+"</td>"
			
		EndIf
	Next
	
	CloseFile file
	Return True
End Function


Function ReadPlayer(html,p,index)

	file=ReadFile (DATA_PATH$+index+"-players.txt")
	
	If Not file Then Return False ; escape if not found
	
	count = ReadLine (file) ; get number of records
	
	For c=1 To count
		id = ReadLine (file) ; read player data
		name$ = ReadLine (file)
		islands = ReadLine (file)
		score = ReadLine (file)
		rank = ReadLine (file)
		allianceid = ReadLine (file)
		alliancetag$ = ReadLine (file)
		
		If id = p Then ; match player
		
			WriteLine html, "<tr>"
			WriteLine html, "<td>"+index+"</td>"
;			WriteLine html, "<td>"+id+"</td>"
			WriteLine html, "<td>"+name$+"</td>"
			WriteLine html, "<td>"+islands+"</td>"
			WriteLine html, "<td>"+score+"</td>"
			WriteLine html, "<td>"+rank+"</td>"
			WriteLine html, "<td>"+allianceid+"</td>"
			WriteLine html, "<td>"+alliancetag$+"</td>"
			
		EndIf
	Next
	
	CloseFile file
	Return True
End Function