;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  Cucco's Tools - IK.com W2 Tools Server
;;  (c) flying_cucco 2007-2008. All rights reserved.
;;  Who needs LAMP when you have Blitz?
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


Const PORT = 80
Const VERSION$ = "1.7.10"
;Const ADMINUSER$ = "flying_cucco"
Const DATA_PATH$ = "data\"
Const DATA_HIST = 39
Const PARAMS = 32
Const LOG_PATH$ = "logs\"
Const LOG_FILE$ = " log.csv"
;Const SPY_PATH$ = "reports\"
Const TABLE_ROWS = 10

;media data
Dim graph_id(5)
Dim graph_data(5,DATA_HIST)

;server data
Global server,timer
Global logfile
Global last_data
;Global last_modified$

;Connection Data
Global TCPstream ;TCP stream id
;Global cookie$ ;auth cookie
Global user$ ;username

;request data
Global get$, agent$, referer$
Dim parameter$(PARAMS) ;incoming request paramters
Dim getparam$(PARAMS-1) ;parameters for GET
;Global page_modified ;has page changed since last cache?

;date strings
Dim date$(DATA_HIST)

;player data
Type Player
	Field id
	Field name$[DATA_HIST]
	Field islands[DATA_HIST]
	Field score[DATA_HIST]
	Field rank[DATA_HIST]
	Field allianceid[DATA_HIST]
	Field alliancetag$[DATA_HIST]
	Field inactive[DATA_HIST]
End Type

;island data
Global island_count
Type Island
	Field ocean
	Field sector
	Field isle
	Field x
	Field y
	Field rulerid[DATA_HIST]
	Field rulername$[DATA_HIST]
	Field allianceid[DATA_HIST]
	Field alliancetag$[DATA_HIST]
End Type

;alliance data
Type Alliance
	Field id
	Field tag$[DATA_HIST]
	Field score[DATA_HIST]
	Field rank[DATA_HIST]
	Field members[DATA_HIST]
	Field islands[DATA_HIST]
	Field inactive[DATA_HIST]
End Type

;; type to hold colo claims
;Type colo
;	Field ocean
;	Field sector
;	Field isle
;	Field playerid
;	Field allianceid
;	Field anon
;	Field status
;	Field date$
;End Type

;;type to hold spy reports
;Type spy
;	Field id$
;	Field ocean
;	Field sector
;	Field isle
;	Field rulerid
;	Field rulername$
;	Field allianceid
;	Field alliancetag$
;	Field date$
;	Field report$
;	Field submit
;	Field public
;End Type

;;type to hold registered users
;Type user
;	Field id
;	Field allianceid
;	Field username$
;	Field pass$
;	Field cookie$
;End Type


;includes
Include "Tools Server Files.bb"
Include "Tools Server Data.bb"
Include "Tools Server Pages.bb"
;Include "CSS.bb"
;Include "Tools Server IPUpdate Mafia.bb"

;set screen
AppTitle "CuccosTools/"+VERSION
;Graphics 300,15,32,2
;SetBuffer FrontBuffer()
;font = LoadFont ("Bitstream Vera Sans Mono",9,False,False,False)
;SetFont font

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Load data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Reload()



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Start Server
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;open server
.startserver
server = CreateTCPServer (PORT)

;retry if failed (port busy)
If Not server Then
	Print "Server not started!"
	Delay 1000
	Goto startserver
EndIf

;WriteLog ("Server started")
SeedRnd MilliSecs()





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Main loop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Repeat

	;listen for incoming connections
	TCPstream = AcceptTCPStream (server)
	
	If TCPstream
			
		;start timing request processing
		timer = MilliSecs()
		
		;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		;Incoming data loop
		;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		Write CurrentTime()+" "

		Repeat
		
			;get incoming data
			incoming$ = ReadLine$ (TCPstream)
		
			;process
			ParseIncoming (TCPstream,incoming$)

				
		Until incoming$ = "" ;end of request

		WriteLog()
		Print get$ ;;minimal "is it working?" screen logging

		;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		;Process command
		;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
		;Check authetication
;		If Authenticate(cookie$)	
			ParseRequestAuth(TCPstream)		
;		Else		
;			ParseRequestUnauth(TCPstream)		
;		EndIf

		;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		;Close Connection
		;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
						
		;close and clear connection
		CloseTCPStream TCPstream
;		cookie$=""
;		user$=""
;		referer$=""
;		agent$=""

		;clear last request
		get$=""
		For i=0 To PARAMS-1
			getparam$(i) = ""
		Next
		
	EndIf
	
;	;check public IP and update forum link
;	CheckIP()
	
	;status
	AppTitle "CuccosTools/"+VERSION+" : "+MilliSecs()

	;pause to free up CPU
	Delay 100
	
Forever







Function ParseIncoming(stream, incoming$)

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;Gather parameters
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	For i=0 To PARAMS
		parameter$(i) = "" ;clear old parameters
	Next

	If incoming$<>""
	
		;convert encoded characters
		If Instr( incoming$, "%" ) Then
			For a = 0 To 255
				incoming$ = Replace$( incoming$, "%" + Right$( Hex$( a ), 2 ), Chr$( a ) )
			Next
		EndIf
		
		break=0 ;start of parameter
		paramcount=0 ;number of parameters processed

		For i=1 To Len(incoming$) ; step through command

			char = Asc(Mid$(incoming$,i,1)) ; parse character
		
			If (char=32) Or (char=38) Or (char=63) Then ; check for delimiter (space, ?, &)
		
				parameter$(paramcount) = Mid$(incoming$,break+1,i-break-1) ;get parameter
			
				break = i ;set to end of this parameter
			
				paramcount = paramcount + 1
				If paramcount = PARAMS+1 Then Goto end_gather ; break if buffer full
				
			EndIf	
		Next
	
		parameter$(paramcount) = Mid$(incoming$,break+1,i-break-1) ;get last parameter

	EndIf
	.end_gather

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;Parse Incoming
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	Select Lower$(parameter$(0))
	Case "get" ;request
		get$=Mid$(incoming$,5) ; log request

		For i=0 To PARAMS-1
			getparam$(i) = parameter$(i+1) ;store request for processing
		Next
		
;	Case "cookie:" ;auth cookie
;		If Instr(parameter$(1),"cucco=")
;			cookie$ = Mid$(parameter$(1),7) ;store password cookie
;		EndIf
	
;	Case "if-modified-since:"
;		If Mid$(incoming$,19) = " "+last_modified$ ;page already cached by browser
;			page_modified = 0
;		EndIf					
	
	;log some other info
;	Case "user-agent:"
;		agent$ = Mid$(incoming$,13)
		
;	Case "referer:"
;		referer$ = Mid$(incoming$,10)
			
	End Select

End Function




;Function Authenticate(pass$)
;
;	If Not (pass$="") ;reject if no cookie
;		
;		For u.user=Each user ;loop users
;			If u\cookie$=pass$ ;check password
;				user$=u\username$ ;set user
;				Return True ;auth ok
;			EndIf
;		Next
;	
;	EndIf		
;	
;	Return False ;auth fail
;
;End Function




Function ParseRequestAuth(stream)

	;command
	Select getparam$(0)

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;Admin Commands
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;	Case "/reload" ;reload database
;		If user$=ADMINUSER$ ;must be admin
;			;WriteLog("("+user$+") Reload!")
;			Reload() ;will take some minutes
;		Else
;			ErrorPage(stream,"unauthorised")
;		EndIf
;		
;	Case "/user"
;		If user$=ADMINUSER$ ;must be admin
;			Select getparam$(1)
;			Case "list" : UserList(stream) : ;WriteLog("("+user$+") List users")
;			Case "new" : AdduserPage(stream) : ;WriteLog("("+user$+") Add user")
;			End Select
;			
;			If Left$(getparam$(1),2) = "u="
;				If Left$(getparam$(2),2)="p="
;					un$=Mid$(getparam$(1),3)
;					pw$=Mid$(getparam$(2),3)
;					;WriteLog("("+user$+") Added new user: "+un$)
;					If AddUser(un$,pw$)
;						UserList(stream)
;					Else
;						ErrorPage(stream,"User already exists or name not found")
;					EndIf
;				EndIf
;			EndIf
;	
;		Else
;			ErrorPage(stream,"unauthorised")
;		EndIf

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;User commands
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	Case "/" ;index
		IndexPage(stream) : ;WriteLog("("+user$+") Index")
		
;	Case "/login" ;request to login
;		If Left$(getparam$(1),2)="u=" Then un$=Mid$(getparam$(1),3)
;		If Left$(getparam$(2),2)="p=" Then pw$=Mid$(getparam$(2),3)
;		Login(stream,un$,pw$)
		
;	Case "/logout"
;		;WriteLog("("+user$+") Logout")
;		For u.user = Each user
;			If u\username$ = user$ Then u\cookie$ = "" ;log out user
;		Next
;		user$=""
;		LoginPage(stream) ; return to login screen
	
	Case "/stats"
		DatabaseStatistics(stream) : ;WriteLog("("+user$+") Database info")
			
	Case "/search"
		Select getparam$(1)
		Case "alliances" : SearchAlliancePage(stream) : ;WriteLog("("+user$+") Alliance search")
		Case "players" : SearchPlayerPage(stream) : ;WriteLog("("+user$+") Player search")
		Case "islands" : SearchIslandPage(stream) : ;WriteLog("("+user$+") Island Search")
		Case "inactive" : SearchInactivePage(stream)
		Default : ErrorPage(stream,"Parser error - invalid request.")
		End Select

		
	Case "/calc"
		If Left$(getparam$(1),6)="ocean=" ;distance calc
			If Left$(getparam$(2),7)="sector="
				If Left$(getparam$(3),5)="isle="
					DistanceCalcPage(stream,Mid(getparam$(1),7),Mid(getparam$(2),8),Mid(getparam$(3),6))
					;WriteLog("("+user$+") Distance calc")
				Else
					ErrorPage(stream,"Parser error - invalid request.")
				EndIf
			Else
				ErrorPage(stream,"Parser error - invalid request.")
			EndIf
		ElseIf Left$(getparam$(1),5)="build"
			
			BuildCalcPage(stream) : ;WriteLog("("+user$+") Build schedule calc")
		Else
			ErrorPage(stream,"Parser error - invalid request.")
		EndIf
					
	Case "/map"
		;search pages
		If getparam$(1)="alliances"
			MapSearchAlliancePage(stream)
			;WriteLog("("+user$+") Alliance maps search")
		
		ElseIf getparam$(1)="players"
			MapSearchPlayerPage(stream)
			;WriteLog("("+user$+") Player maps search")
						
		Else
			ErrorPage(stream,"Parser error - invalid request.")
		End If
		
	Case "/playermappage"
		If Left$(getparam$(1),6) = "ocean=" Then v_ocean = Mid(getparam$(1),7)
		If Left$(getparam$(2),7) = "sector=" Then v_sector = Mid(getparam$(2),8)
		If Left$(getparam$(3),5) = "date=" Then v_date = Mid(getparam$(3),6)
		If Left$(getparam$(4),3) = "a0=" Then a0$ = Mid(getparam$(4),4)
		If Left$(getparam$(5),3) = "a1=" Then a1$ = Mid(getparam$(5),4)
		If Left$(getparam$(6),3) = "a2=" Then a2$ = Mid(getparam$(6),4)
		If Left$(getparam$(7),3) = "a3=" Then a3$ = Mid(getparam$(7),4)
		If Left$(getparam$(8),3) = "a4=" Then a4$ = Mid(getparam$(8),4)
		If Left$(getparam$(9),3) = "a5=" Then a5$ = Mid(getparam$(9),4)
		MapPlayerPage(stream,v_ocean,v_sector,v_date,a0$,a1$,a2$,a3$,a4$,a5$)
		
	Case "/playeroceanmapimage"
		For gp = 0 To PARAMS-1 ;loop params
			For series=0 To 5 ; loop series
				If Left$(getparam$(gp),3) = "a"+series+"=" ;match series
					graph_id(series) = Mid(getparam$(gp),4)
				ElseIf Left$(getparam$(gp),6) = "ocean="
					v_ocean = Mid(getparam$(gp),7)
				ElseIf Left$(getparam$(gp),5) = "date="
					v_date = Mid(getparam$(gp),6)
				EndIf
			Next
		Next
		PlayerOceanMap(stream,v_ocean,v_date)
		
	Case "/playerworldmapimage"
		For gp = 0 To PARAMS-1 ;loop params
			For series=0 To 5 ; loop series
				If Left$(getparam$(gp),3) = "a"+series+"=" ;match series
					graph_id(series) = Mid(getparam$(gp),4)
				ElseIf Left$(getparam$(gp),5) = "date="
					v_date = Mid(getparam$(gp),6)
				EndIf
			Next
		Next
		PlayerWorldMap(stream,v_date)
		
	Case "/playersectormapimage"
		For gp = 0 To PARAMS-1 ;loop params
			For series=0 To 5 ; loop series
				If Left$(getparam$(gp),3) = "a"+series+"=" ;match series
					graph_id(series) = Mid(getparam$(gp),4)
				ElseIf Left$(getparam$(gp),6) = "ocean="
					v_ocean = Mid(getparam$(gp),7)
				ElseIf Left$(getparam$(gp),7) = "sector="
					v_sector = Mid(getparam$(gp),8)
				ElseIf Left$(getparam$(gp),5) = "date="
					v_date = Mid(getparam$(gp),6)
				EndIf
			Next
		Next
		PlayerSectorMap(stream,v_ocean,v_sector,v_date)
		
	Case "/alliancemappage"
		If Left$(getparam$(1),6) = "ocean=" Then v_ocean = Mid(getparam$(1),7)
		If Left$(getparam$(2),7) = "sector=" Then v_sector = Mid(getparam$(2),8)
		If Left$(getparam$(3),5) = "date=" Then v_date = Mid(getparam$(3),6)
		If Left$(getparam$(4),3) = "a0=" Then a0$ = Mid(getparam$(4),4)
		If Left$(getparam$(5),3) = "a1=" Then a1$ = Mid(getparam$(5),4)
		If Left$(getparam$(6),3) = "a2=" Then a2$ = Mid(getparam$(6),4)
		If Left$(getparam$(7),3) = "a3=" Then a3$ = Mid(getparam$(7),4)
		If Left$(getparam$(8),3) = "a4=" Then a4$ = Mid(getparam$(8),4)
		If Left$(getparam$(9),3) = "a5=" Then a5$ = Mid(getparam$(9),4)
		MapAlliancePage(stream,v_ocean,v_sector,v_date,a0$,a1$,a2$,a3$,a4$,a5$)
		
	Case "/alliancesectormapimage"
		For gp = 0 To PARAMS-1 ;loop params
			For series=0 To 5 ; loop series
				If Left$(getparam$(gp),3) = "a"+series+"=" ;match series
					graph_id(series) = Mid(getparam$(gp),4)
				ElseIf Left$(getparam$(gp),6) = "ocean="
					v_ocean = Mid(getparam$(gp),7)
				ElseIf Left$(getparam$(gp),7) = "sector="
					v_sector = Mid(getparam$(gp),8)
				ElseIf Left$(getparam$(gp),5) = "date="
					v_date = Mid(getparam$(gp),6)
				EndIf
			Next
		Next
		AllianceSectorMap(stream,v_ocean,v_sector,v_date)
		
	Case "/allianceoceanmapimage"
		For gp = 0 To PARAMS-1 ;loop params
			For series=0 To 5 ; loop series
				If Left$(getparam$(gp),3) = "a"+series+"=" ;match series
					graph_id(series) = Mid(getparam$(gp),4)
				ElseIf Left$(getparam$(gp),6) = "ocean="
					v_ocean = Mid(getparam$(gp),7)
				ElseIf Left$(getparam$(gp),5) = "date="
					v_date = Mid(getparam$(gp),6)
				EndIf
			Next
		Next
		AllianceOceanMap(stream,v_ocean,v_date)
		
	Case "/allianceworldmapimage"
		For gp = 0 To PARAMS-1 ;loop params
			For series=0 To 5 ; loop series
				If Left$(getparam$(gp),3) = "a"+series+"=" ;match series
					graph_id(series) = Mid(getparam$(gp),4)
				ElseIf Left$(getparam$(gp),5) = "date="
					v_date = Mid(getparam$(gp),6)
				EndIf
			Next
		Next
		AllianceWorldMap(stream,v_date)
		
		
	Case "/alliance"
	
		;WriteLog("("+user$+") SEARCH ALLIANCES")

		For gp = 0 To PARAMS-1
			If Left$(getparam$(gp),4) = "res="
				If Mid(getparam$(gp),5)<>"" Then c_res=1
				v_res = Mid(getparam$(gp),5)
			ElseIf Left$(getparam$(gp),5) = "date="
				If Mid(getparam$(gp),6)<>"" Then c_date=1
				v_date = Mid(getparam$(gp),6)
			ElseIf Left$(getparam$(gp),11) = "allianceid="
				If Mid(getparam$(gp),12)<>"" Then c_allianceid=1
				v_allianceid = Mid(getparam$(gp),12)
			ElseIf Left$(getparam$(gp),12) = "alliancetag="
				If Mid(getparam$(gp),13)<>"" Then c_alliancetag=1
				v_alliancetag$ = Lower$(Mid(getparam$(gp),13))
			ElseIf Left$(getparam$(gp),19) = "alliancetag_search="
				If Mid(getparam$(gp),20)<>"" Then c_alliancetag_search=1
				v_alliancetag_search$ = Lower$(Mid(getparam$(gp),20))
			ElseIf Left$(getparam$(gp),6) = "score="
				If Mid(getparam$(gp),7)<>"" Then c_score=1
				v_score = Mid(getparam$(gp),7)
			ElseIf Left$(getparam$(gp),12) = "score_least="
				If Mid(getparam$(gp),13)<>"" Then c_score_least=1
				v_score_least = Mid(getparam$(gp),13)
			ElseIf Left$(getparam$(gp),11) = "score_most="
				If Mid(getparam$(gp),12)<>"" Then c_score_most=1
				v_score_most = Mid(getparam$(gp),12)
			ElseIf Left$(getparam$(gp),5) = "rank="
				If Mid(getparam$(gp),6)<>"" Then c_rank=1
				v_rank = Mid(getparam$(gp),6)
			ElseIf Left$(getparam$(gp),11) = "rank_least="
				If Mid(getparam$(gp),12)<>"" Then c_rank_least=1
				v_rank_least = Mid(getparam$(gp),12)
			ElseIf Left$(getparam$(gp),10) = "rank_most="
				If Mid(getparam$(gp),11)<>"" Then c_rank_most=1
				v_rank_most = Mid(getparam$(gp),11)
			ElseIf Left$(getparam$(gp),8) = "members="
				If Mid(getparam$(gp),9)<>"" Then c_members=1
				v_members = Mid(getparam$(gp),9)
			ElseIf Left$(getparam$(gp),14) = "members_least="
				If Mid(getparam$(gp),15)<>"" Then c_members_least=1
				v_members_least = Mid(getparam$(gp),15)
			ElseIf Left$(getparam$(gp),13) = "members_most="
				If Mid(getparam$(gp),14)<>"" Then c_members_most=1
				v_members_most = Mid(getparam$(gp),14)
			ElseIf Left$(getparam$(gp),8) = "islands="
				If Mid(getparam$(gp),9)<>"" Then c_islands=1
				v_islands = Mid(getparam$(gp),9)
			ElseIf Left$(getparam$(gp),14) = "islands_least="
				If Mid(getparam$(gp),15)<>"" Then c_islands_least=1
				v_islands_least = Mid(getparam$(gp),15)
			ElseIf Left$(getparam$(gp),13) = "islands_most="
				If Mid(getparam$(gp),14)<>"" Then c_islands_most=1
				v_islands_most = Mid(getparam$(gp),14)
			ElseIf Left$(getparam$(gp),15) = "inactive_least="
				If Mid(getparam$(gp),16)<>"" Then c_inactive_least=1
				v_inactive_least = Mid(getparam$(gp),16)
			ElseIf Left$(getparam$(gp),14) = "inactive_most="
				If Mid(getparam$(gp),15)<>"" Then c_inactive_most=1
				v_inactive_most = Mid(getparam$(gp),15)
			ElseIf Left$(getparam$(gp),14) = "develop_least="
				If Mid(getparam$(gp),15)<>"" Then c_develop_least=1
				v_develop_most = Mid(getparam$(gp),15)
			ElseIf Left$(getparam$(gp),13) = "develop_most="
				If Mid(getparam$(gp),14)<>"" Then c_develop_most=1
				v_develop_most = Mid(getparam$(gp),14)
			EndIf
		Next		
		
		;Super alliance search
		AllianceSearch(stream,c_date,c_allianceid,c_alliancetag,c_alliancetag_search,c_score,c_score_least,c_score_most,c_rank,c_rank_least,c_rank_most,c_members,c_members_least,c_members_most,c_islands,c_islands_least,c_islands_most,c_inactive_least,c_inactive_most,c_develop_least,c_develop_most,v_date,v_allianceid,v_alliancetag$,v_alliancetag_search$,v_score,v_score_least,v_score_most,v_rank,v_rank_least,v_rank_most,v_members,v_members_least,v_members_most,v_islands,v_islands_least,v_islands_most,v_inactive_least,v_inactive_most,v_develop_least,v_develop_most,c_res,v_res)

		
	Case "/player"
	
		;WriteLog("("+user$+") SEARCH PLAYERS")
	
		For gp = 0 To PARAMS-1
			If Left$(getparam$(gp),4) = "res="
				If Mid(getparam$(gp),5)<>"" Then c_res=1
				v_res = Mid(getparam$(gp),5)
			ElseIf Left$(getparam$(gp),5) = "date="
				If Mid(getparam$(gp),6)<>"" Then c_date=1
				v_date = Mid(getparam$(gp),6)
			ElseIf Left$(getparam$(gp),9) = "playerid="
				If Mid(getparam$(gp),10)<>"" Then c_playerid=1
				v_playerid = Mid(getparam$(gp),10)
			ElseIf Left$(getparam$(gp),11) = "playername="
				If Mid(getparam$(gp),12)<>"" Then c_playername=1
				v_playername$ = Lower$(Mid(getparam$(gp),12))
			ElseIf Left$(getparam$(gp),18) = "playername_search="
				If Mid(getparam$(gp),19)<>"" Then c_playername_search=1
				v_playername_search$ = Lower$(Mid(getparam$(gp),19))
			ElseIf Left$(getparam$(gp),6) = "score="
				If Mid(getparam$(gp),7)<>"" Then c_score=1
				v_score = Mid(getparam$(gp),7)
			ElseIf Left$(getparam$(gp),12) = "score_least="
				If Mid(getparam$(gp),13)<>"" Then c_score_least=1
				v_score_least = Mid(getparam$(gp),13)
			ElseIf Left$(getparam$(gp),11) = "score_most="
				If Mid(getparam$(gp),12)<>"" Then c_score_most=1
				v_score_most = Mid(getparam$(gp),12)
			ElseIf Left$(getparam$(gp),5) = "rank="
				If Mid(getparam$(gp),6)<>"" Then c_rank=1
				v_rank = Mid(getparam$(gp),6)
			ElseIf Left$(getparam$(gp),11) = "rank_least="
				If Mid(getparam$(gp),12)<>"" Then c_rank_least=1
				v_rank_least = Mid(getparam$(gp),12)
			ElseIf Left$(getparam$(gp),10) = "rank_most="
				If Mid(getparam$(gp),11)<>"" Then c_rank_most=1
				v_rank_most = Mid(getparam$(gp),11)
			ElseIf Left$(getparam$(gp),11) = "allianceid="
				If Mid(getparam$(gp),12)<>"" Then c_allianceid=1
				v_allianceid = Mid(getparam$(gp),12)
			ElseIf Left$(getparam$(gp),12) = "alliancetag="
				If Mid(getparam$(gp),13)<>"" Then c_alliancetag=1
				v_alliancetag$ = Lower$(Mid(getparam$(gp),13))
			ElseIf Left$(getparam$(gp),8) = "islands="
				If Mid(getparam$(gp),9)<>"" Then c_islands=1
				v_islands = Mid(getparam$(gp),9)
			ElseIf Left$(getparam$(gp),14) = "islands_least="
				If Mid(getparam$(gp),15)<>"" Then c_islands_least=1
				v_islands_least = Mid(getparam$(gp),15)
			ElseIf Left$(getparam$(gp),13) = "islands_most="
				If Mid(getparam$(gp),14)<>"" Then c_islands_most=1
				v_islands_most = Mid(getparam$(gp),14)
			ElseIf Left$(getparam$(gp),15) = "inactive_least="
				If Mid(getparam$(gp),16)<>"" Then c_inactive_least=1
				v_inactive_least = Mid(getparam$(gp),16)
			ElseIf Left$(getparam$(gp),14) = "inactive_most="
				If Mid(getparam$(gp),15)<>"" Then c_inactive_most=1
				v_inactive_most = Mid(getparam$(gp),15)
			ElseIf Left$(getparam$(gp),14) = "develop_least="
				If Mid(getparam$(gp),15)<>"" Then c_develop_least=1
				v_develop_least = Mid(getparam$(gp),15)
			ElseIf Left$(getparam$(gp),13) = "develop_most="
				If Mid(getparam$(gp),14)<>"" Then c_develop_most=1
				v_develop_most = Mid(getparam$(gp),14)
			EndIf
		Next
		
		;Super-duper Player Search
		PlayerSearch(stream,c_date,c_playerid,c_playername,c_playername_search,c_score,c_score_least,c_score_most,c_rank,c_rank_least,c_rank_most,c_allianceid,c_alliancetag,c_islands,c_islands_least,c_islands_most,c_inactive_least,c_inactive_most,c_develop_least,c_develop_most,v_date,v_playerid,v_playername$,v_playername_search$,v_score,v_score_least,v_score_most,v_rank,v_rank_least,v_rank_most,v_allianceid,v_alliancetag$,v_islands,v_islands_least,v_islands_most,v_inactive_least,v_inactive_most,v_develop_least,v_develop_most,c_res,v_res)

		
	Case "/island"
	
		;WriteLog("("+user$+") SEARCH ISLANDS")

		;island search params
		For gp=0 To PARAMS-1
			If Left$(getparam$(gp),4) = "res="
				If Mid(getparam$(gp),5)<>"" Then c_res=1
				v_res = Mid(getparam$(gp),5)
			ElseIf Left$(getparam$(gp),5) = "date="
				If Mid(getparam$(gp),6)<>"" Then check_date=1
				v_date= Mid(getparam$(gp),6)
			ElseIf Left$(getparam$(gp),6) = "ocean="
				If Mid(getparam$(gp),7)<>"" Then check_ocean=1
				v_ocean= Mid(getparam$(gp),7)
			ElseIf Left$(getparam$(gp),7) = "sector="
				If Mid(getparam$(gp),8)<>"" Then check_sector=1
				v_sector= Mid(getparam$(gp),8)
			ElseIf Left$(getparam$(gp),5) = "isle="
				If Mid(getparam$(gp),6)<>"" Then check_isle=1
				v_isle= Mid(getparam$(gp),6)
			ElseIf Left$(getparam$(gp),8) = "x_least="
				If Mid(getparam$(gp),9)<>"" Then check_x_least=1
				v_x_least= Mid(getparam$(gp),9)
			ElseIf Left$(getparam$(gp),7) = "x_most="
				If Mid(getparam$(gp),8)<>"" Then check_x_most=1
				v_x_most= Mid(getparam$(gp),8)
			ElseIf Left$(getparam$(gp),8) = "y_least="
				If Mid(getparam$(gp),9)<>"" Then check_least=1
				v_y_least= Mid(getparam$(gp),9)
			ElseIf Left$(getparam$(gp),7) = "y_most="
				If Mid(getparam$(gp),8)<>"" Then check_y_most=1
				v_y_most= Mid(getparam$(gp),8)
			ElseIf Left$(getparam$(gp),9) = "playerid="
				If Mid(getparam$(gp),10)<>"" Then check_playerid=1
				v_playerid= Mid(getparam$(gp),10)
			ElseIf Left$(getparam$(gp),11) = "playername="
				If Mid(getparam$(gp),12)<>"" Then check_playername=1
				v_playername= Lower$(Mid(getparam$(gp),12))
			ElseIf Left$(getparam$(gp),18) = "playername_search="
				If Mid(getparam$(gp),19)<>"" Then check_playername_search=1
				v_playername_search= Lower$(Mid(getparam$(gp),19))
			ElseIf Left$(getparam$(gp),11) = "allianceid="
				If Mid(getparam$(gp),12)<>"" Then check_allianceid=1
				v_allianceid= Mid(getparam$(gp),12)
			ElseIf Left$(getparam$(gp),12) = "alliancetag="
				If Mid(getparam$(gp),13)<>"" Then check_alliancetag=1
				v_alliancetag= Lower$(Mid(getparam$(gp),13))
			ElseIf Left$(getparam$(gp),15) = "inactive_least="
				If Mid(getparam$(gp),16)<>"" Then check_inactive_least=1
				v_inactive_least= Mid(getparam$(gp),16)
			ElseIf Left$(getparam$(gp),14) = "inactive_most="
				If Mid(getparam$(gp),15)<>"" Then check_inactive_most=1
				v_inactive_most= Mid(getparam$(gp),15)
			ElseIf Left$(getparam$(gp),14) = "develop_least="
				If Mid(getparam$(gp),15)<>"" Then check_develop_least=1
				v_develop_least= Mid(getparam$(gp),15)
			ElseIf Left$(getparam$(gp),13) = "develop_most="
				If Mid(getparam$(gp),14)<>"" Then check_develop_most=1
				v_develop_most= Mid(getparam$(gp),14)
			ElseIf Left$(getparam$(gp),15) = "distance_least="
				If Mid(getparam$(gp),16)<>"" Then check_distance_least=1
				v_distance_least= Mid(getparam$(gp),16)
			ElseIf Left$(getparam$(gp),14) = "distance_most="
				If Mid(getparam$(gp),15)<>"" Then check_distance_most=1
				v_distance_most= Mid(getparam$(gp),15)
			ElseIf Left$(getparam$(gp),15) = "distance_ocean="
				v_distance_ocean= Mid(getparam$(gp),16)
			ElseIf Left$(getparam$(gp),16) = "distance_sector="
				v_distance_sector= Mid(getparam$(gp),17)
			ElseIf Left$(getparam$(gp),14) = "distance_isle="
				v_distance_isle= Mid(getparam$(gp),15)
			ElseIf Left$(getparam$(gp),6) = "colod="
				c_colod = 1
			ElseIf Left$(getparam$(gp),6) = "moved="
				c_moved = 1
			ElseIf Left$(getparam$(gp),10) = "not_colod="
				c_not_colod = 1
			ElseIf Left$(getparam$(gp),10) = "not_moved="
				c_not_moved = 1
			EndIf
		Next

		;Awesome Island Search
		IslandSearch(stream,check_date,check_ocean,check_sector,check_isle,check_x_least,check_x_most,check_y_least,check_y_most,check_playerid,check_playername,check_playername_search,check_allianceid,check_alliancetag,check_inactive_least,check_inactive_most,check_develop_least,check_develop_most,check_distance_least,check_distance_most,v_date,v_ocean,v_sector,v_isle,v_x_least,v_x_most,v_y_least,v_y_most,v_playerid,v_playername$,v_playername_search$,v_allianceid,v_alliancetag$,v_inactive_least,v_inactive_most,v_develop_least,v_develop_most,v_distance_least,v_distance_most,v_distance_ocean,v_distance_sector,v_distance_isle,c_res,v_res,c_colod,c_moved,c_not_colod,c_not_moved)
		
		
		
	Case "/distance"
		If Left$(getparam$(1),3)="o1="
			If Left$(getparam$(2),3)="s1="
				If Left$(getparam$(3),3)="i1="
					If Left$(getparam$(4),3)="o2="
						If Left$(getparam$(5),3)="s2="
							If Left$(getparam$(6),3)="i2="
							
								o1=Mid$(getparam$(1),4) : s1=Mid$(getparam$(2),4) : i1=Mid$(getparam$(3),4)
								o2=Mid$(getparam$(4),4) : s2=Mid$(getparam$(5),4) : i2=Mid$(getparam$(6),4)
								CalcDistance(stream,o1,s1,i1,o2,s2,i2)
								;WriteLog("("+user$+") Calculated distance")
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
		
	Case "/history"
		;results
		If Left$(getparam$(1),11)="allianceid=" Then

			HistoryAllianceSearch(stream,Mid(getparam$(1),12))
			;WriteLog("("+user$+") Alliace history")
			
		ElseIf Left$(getparam$(1),9)="playerid="

			HistoryPlayerSearch(stream,Mid(getparam$(1),10))
			;WriteLog("("+user$+") Player history")
			
		ElseIf Left$(getparam$(1),12)="alliancetag="

			temp$ = Lower$(Mid$(getparam$(1),13))
			
			For a.alliance = Each alliance ;find id from alliance tag
				If Lower$(a\tag$[0]) = temp$
					id = a\id
					Exit
				EndIf
			Next

			HistoryAllianceSearch(stream,id)
			;WriteLog("("+user$+") Alliance history: "+id)
			
		ElseIf Left$(getparam$(1),11)="playername="

			temp$=Lower$(Mid$(getparam$(1),12))
			
			For p.player = Each player ;find id from player name
				If Lower$(p\name$[0]) = temp$
					id = p\id
					Exit
				EndIf
			Next

			HistoryPlayerSearch(stream,id)
			;WriteLog("("+user$+") Player history: "+id)
			
		ElseIf Left$(getparam$(1),6)="ocean="
			If Left$(getparam$(2),7)="sector="
				If Left$(getparam$(3),5)="isle="
				
					HistoryIslandSearch(stream,Mid(getparam$(1),7),Mid(getparam$(2),8),Mid(getparam$(3),6))
					;WriteLog("("+user$+") Island history")
				Else
					ErrorPage(stream,"Parser error - invalid request.")
				EndIf
			Else
				ErrorPage(stream,"Parser error - invalid request.")
			EndIf

		;search pages
		ElseIf getparam$(1)="alliances" Then
			HistoryAlliancePage(stream)
			;WriteLog("("+user$+") Alliance history search")
			
		ElseIf getparam$(1)="players"
			HistoryPlayerPage(stream)
			;WriteLog("("+user$+") Player history search")
			
		ElseIf getparam$(1)="islands"
			HistoryIslandPage(stream)
			;WriteLog("("+user$+") Island history search")
	
		Else
			ErrorPage(stream,"Parser error - invalid request.")
		EndIf

	Case "/build" ; index

		;parse arguments
		For gp = 0 To PARAMS-1
			If Left$(getparam$(gp),5) = "gold=" : gold = Mid(getparam$(gp),6)
			ElseIf Left$(getparam$(gp),6) = "stone=" : stone = Mid(getparam$(gp),7)
			ElseIf Left$(getparam$(gp),7) = "lumber=" : lumber = Mid(getparam$(gp),8)
			ElseIf Left$(getparam$(gp),4) = "sws=" : sws = Mid(getparam$(gp),5)
			ElseIf Left$(getparam$(gp),4) = "sms=" : sms = Mid(getparam$(gp),5)
			ElseIf Left$(getparam$(gp),3) = "ws=" : ws = Mid(getparam$(gp),4)
			ElseIf Left$(getparam$(gp),3) = "ms=" : ms = Mid(getparam$(gp),4)
			ElseIf Left$(getparam$(gp),3) = "st=" : st = Mid(getparam$(gp),4)
			ElseIf Left$(getparam$(gp),3) = "sf=" : sf = Mid(getparam$(gp),4)
			ElseIf Left$(getparam$(gp),2) = "a=" : ar = Mid(getparam$(gp),3)
			ElseIf Left$(getparam$(gp),2) = "c=" : ca = Mid(getparam$(gp),3)
			EndIf
		Next
			
		CalcBuild(stream,gold,stone,lumber,sws,sms,ws,ms,st,sf,ar,ca)

	Case "/graph"
		If getparam$(1)="alliances" Then
			GraphSearchAlliancePage(stream)
		ElseIf getparam$(1)="players" Then
			GraphSearchPlayerPage(stream)
		Else
			ErrorPage(stream,"Parser error - invalid request.")
		EndIf

	Case "/alliancegraphpage"
		If Left$(getparam$(1),3) = "a0=" Then a0$ = Mid(getparam$(1),4)
		If Left$(getparam$(2),3) = "a1=" Then a1$ = Mid(getparam$(2),4)
		If Left$(getparam$(3),3) = "a2=" Then a2$ = Mid(getparam$(3),4)
		If Left$(getparam$(4),3) = "a3=" Then a3$ = Mid(getparam$(4),4)
		If Left$(getparam$(5),3) = "a4=" Then a4$ = Mid(getparam$(5),4)
		If Left$(getparam$(6),3) = "a5=" Then a5$ = Mid(getparam$(6),4)
		GraphAlliancePage(stream,a0$,a1$,a2$,a3$,a4$,a5$)
		
	Case "/alliancegraphimage"
		For gp = 0 To PARAMS-1 ;loop params
			For series=0 To 5 ; loop series
				If Left$(getparam$(gp),3) = "a"+series+"=" ;match series
					graph_id(series) = Mid(getparam$(gp),4)
				EndIf
			Next
		Next
		Graph(stream,0)

	Case "/playergraphpage"
		If Left$(getparam$(1),3) = "a0=" Then a0$ = Mid(getparam$(1),4)
		If Left$(getparam$(2),3) = "a1=" Then a1$ = Mid(getparam$(2),4)
		If Left$(getparam$(3),3) = "a2=" Then a2$ = Mid(getparam$(3),4)
		If Left$(getparam$(4),3) = "a3=" Then a3$ = Mid(getparam$(4),4)
		If Left$(getparam$(5),3) = "a4=" Then a4$ = Mid(getparam$(5),4)
		If Left$(getparam$(6),3) = "a5=" Then a5$ = Mid(getparam$(6),4)
		GraphPlayerPage(stream,a0$,a1$,a2$,a3$,a4$,a5$)
		
	Case "/playergraphimage"
		For gp = 0 To PARAMS-1 ;loop params
			For series=0 To 5 ; loop series
				If Left$(getparam$(gp),3) = "a"+series+"=" ;match series
					graph_id(series) = Mid(getparam$(gp),4)
				EndIf
			Next
		Next
		Graph(stream,1)
		
		
		
;	Case "/spy"
;		SpyPage(stream)
		
;	Case "/newspy"	
;		public = False
;		For gp=0 To PARAMS-1
;			If Left$(getparam$(gp),2) = "o="
;				ocean = Mid(getparam$(gp),3)
;			ElseIf Left$(getparam$(gp),2) = "s="
;				sector = Mid(getparam$(gp),3)
;			ElseIf Left$(getparam$(gp),2) = "i="
;				isle = Mid(getparam$(gp),3)
;			ElseIf Left$(getparam$(gp),2) = "r="
;				report$ = Mid(getparam$(gp),3)
;			ElseIf Left$(getparam$(gp),2) = "p="
;				public = True
;			EndIf
;		Next
;		NewSpy(stream,ocean,sector,isle,report$,public)
	
;	Case "/findspy"
;		v_allianceid = -1
;		For gp=0 To PARAMS-1
;			If Left$(getparam$(gp),2) = "o="
;				v_ocean = Mid(getparam$(gp),3)
;			ElseIf Left$(getparam$(gp),2) = "s="
;				v_sector = Mid(getparam$(gp),3)
;			ElseIf Left$(getparam$(gp),2) = "i="
;				v_isle = Mid(getparam$(gp),3)
;			ElseIf Left$(getparam$(gp),2) = "p="
;				v_playerid = Mid(getparam$(gp),3)
;			ElseIf Left$(getparam$(gp),2) = "n="
;				v_playername$ = Mid(getparam$(gp),3)
;			ElseIf Left$(getparam$(gp),2) = "a="
;				v_allianceid = Mid(getparam$(gp),3)
;				If Mid(getparam$(gp),3)="" Then v_allianceid=-1
;			ElseIf Left$(getparam$(gp),2) = "t="
;				v_alliancetag$ = Mid(getparam$(gp),3)
;			EndIf
;		Next
;		Print 
;		SpyReports(stream,v_allianceid,v_alliancetag$,v_playerid,v_playername$,v_ocean,v_sector,v_isle)
		
;	Case "/deletespy"
;		SpyDelete(stream,getparam$(1))
		
		
	Case "/arch"
		For gp=0 To PARAMS-1
			If Left$(getparam$(gp),2) = "o=" : v_o = Mid(getparam$(gp),3)
			ElseIf Left$(getparam$(gp),2) = "s=" : v_s = Mid(getparam$(gp),3)
			ElseIf Left$(getparam$(gp),2) = "i=" : v_i = Mid(getparam$(gp),3)
			ElseIf Left$(getparam$(gp),2) = "p=" : v_p = Mid(getparam$(gp),3)
			ElseIf Left$(getparam$(gp),2) = "a=" : v_a = Mid(getparam$(gp),3)
			EndIf
		Next
		If v_a Then
			ArchiveAlliance(stream,v_a)
		ElseIf v_p Then
			ArchivePlayer(stream,v_p)
		Else
			ArchiveIsland(stream,v_o,v_s,v_i)
		EndIf

;	Case "/css"
;		CSS(stream)
;		;WriteLog("CSS")

	Case "/favicon.ico"
		NotFound(stream)
		;WriteLog("Stupid bookmark icon")
								
	Default ;no matches: error
		ErrorPage(stream,"Parser error - invalid request.")

	End Select

End Function





;Function ParseRequestUnauth(stream)
;
;	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	;Process command
;	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;	;command
;	Select getparam$(0)
;	
;;	Case "/css"
;;		CSS(stream)
;;		;WriteLog("CSS")
;		
;	Case "/login" ;request to login
;		If Left$(getparam$(1),2)="u=" Then un$=Mid$(getparam$(1),3)
;		If Left$(getparam$(2),2)="p=" Then pw$=Mid$(getparam$(2),3)
;		Login(stream,un$,pw$)
;	
;	Case "/info"
;		InfoPage(stream)
;		
;	Case "/robots.txt"
;		NotFound(stream)
;		;WriteLog("ROBOT")
;
;	Case "/favicon.ico"
;		NotFound(stream)
;		;WriteLog("Stupid bookmark icon")
;			
;	Default ;no other pages can be loaded, show login page
;		LoginPage(stream)
;		;WriteLog("Not logged in!")
;		
;	End Select
;	
;End Function